import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class dbmhs extends JFrame implements ActionListener
{

   Container con;
   JLabel lbljudul, lblnim, lblnama, lblalamat;
   JTextField txtnim, txtnama, txtalamat;
   JButton btncari, btntambah, btnkeluar, btnnext, btnprevious, btnfirst, btnlast;
   JPanel panelatas, paneltengah, panelbawah, panelbawah1,panelbawah2;
   String strnim[], strnama[], stralamat[],strtemp;
   int indeks,counter, gerak=0;
   BufferedReader br;
   BufferedWriter bw;

   public dbmhs()
     {
		 super("Database Mahasiswa");
		 con = getContentPane();


		 lblnim = new JLabel("NIM");
		 txtnim = new JTextField(10);

		 lblnama = new JLabel("Nama");
		 txtnama = new JTextField(20);

		 lblalamat = new JLabel("Alamat");
		 txtalamat = new JTextField(30);

		 btnnext = new JButton(">");
		 btnnext.addActionListener(this);

		 btnprevious = new JButton("<");
		 btnprevious.addActionListener(this);

		 btnfirst = new JButton("<<");
		 btnfirst.addActionListener(this);

		 btnlast = new JButton(">>");
		 btnlast.addActionListener(this);

		 btncari = new JButton("Search");
		 btncari.addActionListener(this);

		 btntambah = new JButton("Tambah");
		 btntambah.addActionListener(this);

		 btnkeluar = new JButton("Keluar");
		 btnkeluar.addActionListener(this);


		 lbljudul = new JLabel("Informasi Mahasiswa");

		 panelatas = new JPanel(new FlowLayout(FlowLayout.CENTER,1,5));
		 panelatas.add(lbljudul);

		 paneltengah = new JPanel(new GridLayout(4,2));
		 paneltengah.add(new JLabel(""));
		 paneltengah.add(new JLabel(""));
		 paneltengah.add(lblnim);
		 paneltengah.add(txtnim);
		 paneltengah.add(lblnama);
		 paneltengah.add(txtnama);
		 paneltengah.add(lblalamat);
		 paneltengah.add(txtalamat);

		 panelbawah1 = new JPanel(new FlowLayout(FlowLayout.CENTER,1,1));
 		 panelbawah1.add(btnfirst);
 		 panelbawah1.add(btnprevious);
 		 panelbawah1.add(btnnext);
 		 panelbawah1.add(btnlast);


		 panelbawah2 = new JPanel(new FlowLayout(FlowLayout.CENTER,1,1));
		 panelbawah2.add(btntambah);
		 panelbawah2.add(btncari);
		 panelbawah2.add(btnkeluar);

		 panelbawah = new JPanel(new GridLayout(4,1));
		 panelbawah.add(new JLabel(""));
		 panelbawah.add(new JLabel(""));
		 panelbawah.add(panelbawah1);
		 panelbawah.add(panelbawah2);


		 con.add(panelatas,BorderLayout.NORTH);
		 con.add(paneltengah,BorderLayout.CENTER);
		 con.add(panelbawah,BorderLayout.SOUTH);


		 setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);


		 pack();
		 setSize(250,280);
		 setResizable(false);
		 show();


         strnim = new String[20];
		 strnama = new String[20];
		 stralamat = new String[20];

		 kumpul_data();

		 txtnim.disable();
		 txtnama.disable();
		 txtalamat.disable();

		 txtnim.setText(strnim[0]);
     	 txtnama.setText(strnama[0]);
	     txtalamat.setText(stralamat[0]);
     }

   public void kumpul_data()
   {

	  try
	  	 {
	  		br = new BufferedReader(new FileReader("data.dat"));
	  		counter=0;
	  		while ((strtemp=br.readLine())!=null)
	  		   {
				  indeks = strtemp.indexOf(";");
				  strnim[counter] = strtemp.substring(0,indeks);
				  strtemp = strtemp.substring(indeks+1);

				  indeks = strtemp.indexOf(";");
				  strnama[counter] = strtemp.substring(0,indeks);
				  strtemp = strtemp.substring(indeks+1);

				  stralamat[counter] = strtemp;
				  counter=counter+1;
			   }
			br.close();
		   }catch(FileNotFoundException ff)
		     {
				 JOptionPane.showMessageDialog(null, "File data.dat Tidak Ditemukan");
			 }
		    catch(IOException ioe)
		     {
				 JOptionPane.showMessageDialog(null, "Terjadi Kesalahan I/O");
			 };


   }


   public void cari_data()
   {
	   String strcari;
	   boolean penanda=false;
	   strcari = JOptionPane.showInputDialog("Masukkan Kata yang ingin Dicari : ");
	   for (int a=0; a<counter; a++)
	     {
			 if ( (strnim[a].equalsIgnoreCase(strcari)) || (strnama[a].equalsIgnoreCase(strcari)) || (stralamat[a].equalsIgnoreCase(strcari)) )
			    {
					txtnim.setText(strnim[a]);
					txtnama.setText(strnama[a]);
				    txtalamat.setText(stralamat[a]);
				    penanda=true;
				    break;
				}
		 }
	  if (penanda)
	     {
			 JOptionPane.showMessageDialog(null, "Hore !!! Data yang anda cari Ketemu");
		 }
	  else
	     {
			 JOptionPane.showMessageDialog(null, "Maaf Tidak Ketemu Data yang anda cari");
		 }


   }

   public void tambah_data()
   {
	  if (btntambah.getText().equals("Tambah"))
	  {

	    txtnim.enable();
	    txtnama.enable();
	    txtalamat.enable();
	    btnnext.setVisible(false);
	    btnprevious.setVisible(false);
	    btnfirst.setVisible(false);
	    btnlast.setVisible(false);
	    btncari.setVisible(false);
	    btnkeluar.setVisible(false);


	    txtnim.setText("");
	    txtnama.setText("");
	    txtalamat.setText("");
	    txtnim.grabFocus();
	    btntambah.setText("Save");

   	  }
   	  else
   	  {
		if (txtnim.getText().length()<=0)
		   {
			   JOptionPane.showMessageDialog(null, "Nim Harus Diisi");
			   txtnim.grabFocus();
		   }
		else if (txtnama.getText().length()<=0)
		   {
			   JOptionPane.showMessageDialog(null, "Nama Harus Diisi");
			   txtnama.grabFocus();
		   }
		else if (txtalamat.getText().length()<=0)
		   {
			   JOptionPane.showMessageDialog(null, "Alamat Harus Diisi");
			   txtalamat.grabFocus();
		   }
		else
		   {
		       txtnim.disable();
			   txtnama.disable();
			   txtalamat.disable();
			   btnnext.setVisible(true);
			   btnprevious.setVisible(true);
			   btnfirst.setVisible(true);
			   btnlast.setVisible(true);
			   btncari.setVisible(true);
			   btnkeluar.setVisible(true);


	  		   try
	  			 {
	  				bw = new BufferedWriter(new FileWriter("data.dat",true));
	  				String strtambahdata;
					strtambahdata = "\n" + txtnim.getText() + ";" + txtnama.getText() + ";" + txtalamat.getText();
					bw.write(strtambahdata);
					bw.close();
				 }catch(FileNotFoundException ff)
				     {
						 JOptionPane.showMessageDialog(null, "File data.dat Tidak Ditemukan");
					 }
				  catch(IOException ioe)
				     {
						 JOptionPane.showMessageDialog(null, "Terjadi Kesalahan I/O");
					 };

			   JOptionPane.showMessageDialog(null, "Data Telah Berhasil Disimpan");
			   btntambah.setText("Tambah");
			   kumpul_data();
			   txtnim.setText(strnim[counter-1]);
			   txtnama.setText(strnama[counter-1]);
		       txtalamat.setText(stralamat[counter-1]);
	       }
	  }


   }


   public static void main(String[] args)
     {
        dbmhs data = new dbmhs();
     }

   public void actionPerformed(ActionEvent ae)
     {
		if (ae.getSource().equals(btnfirst))
		   {
	 		 txtnim.setText(strnim[0]);
	     	 txtnama.setText(strnama[0]);
		     txtalamat.setText(stralamat[0]);
		   }
		else if (ae.getSource().equals(btnprevious))
		   {
			 if ((gerak-1)>=0)
			 {
			 gerak=gerak-1;
	 		 txtnim.setText(strnim[gerak]);
	     	 txtnama.setText(strnama[gerak]);
		     txtalamat.setText(stralamat[gerak]);
		 	 }
		   }
		else if (ae.getSource().equals(btnnext))
		   {
			 if ((gerak+1)<counter)
			 {
		     gerak=gerak+1;
	 		 txtnim.setText(strnim[gerak]);
	     	 txtnama.setText(strnama[gerak]);
		     txtalamat.setText(stralamat[gerak]);
		 	 }
		   }
		else if (ae.getSource().equals(btnlast))
		   {
	 		 txtnim.setText(strnim[counter-1]);
	     	 txtnama.setText(strnama[counter-1]);
		     txtalamat.setText(stralamat[counter-1]);
		   }
		else if (ae.getSource().equals(btntambah))
		   {
				tambah_data();
		   }
		else if (ae.getSource().equals(btncari))
		   {
				cari_data();
		   }
		else if (ae.getSource().equals(btnkeluar))
		   {
				JOptionPane.showMessageDialog(null, "Terima Kasih \n\n Created : Hery Hendra");
				System.exit(0);
		   }

     }
}